import { EmitterShapeBase, type IRandomPositionData } from "@tsparticles/plugin-emitters";
import { type ICoordinates, type IDimension, type IRgba } from "@tsparticles/engine";
import type { CanvasPixelData } from "./types";
import type { EmittersCanvasShapeOptions } from "./Options/Classes/EmittersCanvasShapeOptions.js";
export declare class EmittersCanvasShape extends EmitterShapeBase<EmittersCanvasShapeOptions> {
    filter: (pixel: IRgba) => boolean;
    pixelData: CanvasPixelData;
    scale: number;
    constructor(position: ICoordinates, size: IDimension, fill: boolean, options: EmittersCanvasShapeOptions);
    init(): Promise<void>;
    randomPosition(): IRandomPositionData | null;
    resize(position: ICoordinates, size: IDimension): void;
}
