(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TextLinesOptions = void 0;
    const engine_1 = require("@tsparticles/engine");
    class TextLinesOptions {
        constructor() {
            this.separator = "\n";
            this.spacing = 0;
        }
        load(data) {
            if ((0, engine_1.isNull)(data)) {
                return;
            }
            if (data.separator !== undefined) {
                this.separator = data.separator;
            }
            if (data.spacing !== undefined) {
                this.spacing = data.spacing;
            }
        }
    }
    exports.TextLinesOptions = TextLinesOptions;
});
